#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#define K_MAX 13

static int chk_prime() ;

int main(argc,argv)
int argc ;
char **argv ;
{
  static long long n,ten[19] ;
  static long pat,wpat,two[19] ;
  static int c[2] ;
  static int b[19] ;
  static int key,sw,lstart,lend,hstart,i,k ;

  if(argc != 2) goto arg_err ;
  if(sscanf(argv[1],"%d",&key) == EOF) goto arg_err ;
  if(key<1 || key>98) goto arg_err ;
  c[0] = key%10 ;
  c[1] = key/10 ;
  if(c[0]==c[1]) goto prm_err1 ;
  if(c[0]!=1 && c[0]!=3 && c[0]!=7 && c[0]!=9 && c[1]!=1 && c[1]!=3 && c[1]!=7 && c[1]!=9) goto prm_err2 ;
  if(c[0]>c[1]) {
    sw = c[0] ;
    c[0] = c[1] ;
    c[1] = sw ;
  }
  lstart = 1 ;
  lend = 0 ;
  hstart = 0 ;
  if(c[0]==1 || c[0]==3 || c[0]==7 || c[0]==9) lstart = 0 ;
  if(c[1]==1 || c[1]==3 || c[1]==7 || c[1]==9) lend = 1 ;
  if(c[0]==0) hstart = 1 ;
  ten[0] = 1 ;
  two[0] = 1 ;
  for(i=1;i<19;i++) {
    ten[i] = ten[i-1]*10 ;
    two[i] = two[i-1]*2 ;
  }
  for(k=2;k<=K_MAX;k++) {
    for(b[k-1]=hstart;b[k-1]<=1;b[k-1]++) {
      for(pat=0;pat<two[k-2];pat++) {
        wpat = pat ;
        for(i=1;i<k-1;i++) {
          b[i] = wpat%2 ;
          wpat/=2 ;
        }
        for(b[0]=lstart;b[0]<=lend;b[0]++) {
          n = 0 ;
          for(i=0;i<k;i++) {
            n+=c[b[i]]*ten[i] ;
          }
          if(chk_prime(n)==1) {
            printf("%lld\n",n) ;
            fflush(stdout) ;
          }
        }
      }
    }
  }
  exit(0) ;

arg_err:
  fprintf(stderr,"Usage: %s two_figures\n",argv[0]) ;
  exit(1) ;

prm_err1:
  fprintf(stderr,"Specify two different figures.\n") ;
  exit(1) ;

prm_err2:
  fprintf(stderr,"Figures must include 1, 3, 7 or 9.\n") ;
  exit(1) ;
}

static int chk_prime(x)
long long x ;
{
  static int fg ;
  static long d,chk_end ;

  chk_end = (long)floor(sqrt(x)) ;
  fg = 1 ;
  if(x<2||(x>2 && x%2==0)) fg = 0 ;
  for(d=3;fg==1&&d<=chk_end;d+=2) {
    if(x%d==0) fg = 0 ;
  }
  return(fg) ;
}
