#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#define K_MAX 19

static int chk_prime() ;

int main(argc,argv)
int argc ;
char **argv ;
{
  static long long n ;
  static int l[4] = {1,3,7,9} ;
  static int pat[19] ;
  static char chr[7] ;
  static int num[7],stt[7],end[7] ;
  static int len,i,nchr,ichr,inum ;
  static char wc ;

  if(argc != 2) goto arg_err ;
  len = strlen(argv[1]) ;
  if(len>K_MAX || len<3) goto pat_err1 ;
  chr[0] = argv[1][len-1] ;
  pat[len-1] = 0 ;
  nchr = 1 ;
  for(i=0;i<len-1;i++) {
    wc = argv[1][i] ;
    for(ichr=0;ichr<nchr&&chr[ichr]!=wc;ichr++) ;
    if(ichr==nchr) {
      chr[nchr] = wc ;
      nchr++ ;
    }
    pat[i] = ichr ;
  }
  if(nchr>7) goto pat_err2 ;
  for(i=1;i<nchr;i++) {
    stt[i] = 0 ;
    end[i] = 9 ;
  }
  for(i=nchr;i<7;i++) {
    stt[i] = -i ;
    end[i] = -i ;
  }
  if(pat[0]>0) {
    stt[pat[0]] = 1 ;
  }
  for(inum=0;inum<4;inum++) {
    num[0] = l[inum] ;
    for(num[1]=stt[1];num[1]<=end[1];num[1]++) {
      for(num[2]=stt[2];num[2]<=end[2];num[2]++) {
        for(num[3]=stt[3];num[3]<=end[3];num[3]++) {
          for(num[4]=stt[4];num[4]<=end[4];num[4]++) {
            for(num[5]=stt[5];num[5]<=end[5];num[5]++) {
              for(num[6]=stt[6];num[6]<=end[6];num[6]++) {
                n = 0 ;
                for(i=0;i<len;i++) {
                  n = n*10+num[pat[i]] ;
                }
                if(chk_prime(n)==1) {
                  printf("%lld\n",n) ;
                  fflush(stdout) ;
                }
              }
            }
          }
        }
      }
    }
  }
  exit(0) ;

arg_err:
  fprintf(stderr,"Usage: %s pattern\n",argv[0]) ;
  exit(1) ;

pat_err1:
  fprintf(stderr,"Pattern length must be 3 - 19.\n") ;
  exit(1) ;

pat_err2:
  fprintf(stderr,"Maximum number of letter variations is 7.\n") ;
  exit(1) ;
}

static int chk_prime(x)
long long x ;
{
  static int fg ;
  static long d,chk_end ;

  chk_end = (long)floor(sqrt(x)) ;
  fg = 1 ;
  if(x<2||(x>2 && x%2==0)) fg = 0 ;
  for(d=3;fg==1&&d<=chk_end;d+=2) {
    if(x%d==0) fg = 0 ;
  }
  return(fg) ;
}
